// V1.2 12/17/2017 Wenderelais jetzt OK
// Ich habe bewusst auf elegante defines etc. verzichtet, um das Programm auch fuer Anfaenger 
// verstaendlich zu halten
// http://www.arduinolibraries.info/libraries/accel-stepper , habe Version 1.57.1 verwendet
// http://www.arduinolibraries.info/libraries/i-rremote , habe Version 2.0.1
// Geandertes <boarddefs.h> mit hochgeladen
// Wie man .zip Dateien einbindet, siehe 
// In <boarddefs.h> zu finden in Arduino-IRremote-master Timer 1 fuer ATMega 328 (Zeile 144) definieren!
// Nur notwendig, wenn auch IR verwendet wird, sonst beissen sich Timer 1 und Timer 2
// da AccelStepper Timer 2 verwendet 
#include <boarddefs.h>
#include <IRremote.h>
#include <IRremoteInt.h> //IR Bibliotheken einbinden
#include <IRremote.h>  
#include <ir_Lego_PF_BitStreamEncoder.h>
#include <AccelStepper.h>  // Stepper Bibliothek einbinden
#define HALFSTEP 8         // 8 Schritte pro Sequenz d.h. Halbschrittbetrieb 
                           // 28BYJ-48 funktioniert damit am Besten
// Motor pin am Arduino definieren
#define motorPin1  4     // IN1 on the ULN2003 driver 1
#define motorPin2  5     // IN2 on the ULN2003 driver 1
#define motorPin3  6     // IN3 on the ULN2003 driver 1 Achtung! Reihenfolge beachten
#define motorPin4  7     // IN4 on the ULN2003 driver 1

const int irReceiverPin = 2;  //IR-Empfaenger an pin2 anschliessen
IRrecv irrecv(irReceiverPin); //IR- Empfaeenger definieren
decode_results results;       // und Struktur fuer empfangene Daten aufsetzen (die letzten beiden Zeilen 
                              // muss man nicht verstehen ;-)

int endSchalter = 0;         // Variable fuer den Endschalter

// Steppertreiber initialisieren mit Pin Sequenz IN1-IN3-IN2-IN4
// damit AccelStepper mit 28BYJ-48 richtig funktioniert

AccelStepper stepper1(HALFSTEP, motorPin1, motorPin3, motorPin2, motorPin4);

// Arduino Programme haben alle die Struktur 
// void setup() die einmal zum Start durchlaufen wird
// void loop() , das dann endlos wiederholt wird

void setup() {
  pinMode(12, INPUT);          // Pin 12 als Eingang fuer Endschalter mit internem Widerstand definieren
  digitalWrite (12,HIGH);     // Sollte eigentlich nicht notwendig sein, aber schadet auch nicht
  pinMode (13, OUTPUT);       // Pin 13 als Relaisausgang fuer Polaritaetswechsel der Buehne
  digitalWrite (13,LOW);      // Anfangszustand "Aus"
  
  irrecv.enableIRIn();       // IR-Empfaenger initialisieren 
  Serial.begin(115200);      // Serielle Schnittstelle zum Laptop initialisieren,
                             // mit Tools->Serial Monitor kann man Meldungen an den Steuerrechner senden
  Serial.println("Hello");   // und gleich mal probieren
                             // Uebrigens Monitor erst aktivieren, wenn der "Upload" des Programms erfolgt ist.
                             // Wenn man den Beginn des Programms verfolgen will, einfach die Reset-Taste
                             // am Arduino Board druecken. Ohne angeschlossenen Rechner gehen die Meldungen
                             // einfach "ins Leere"

  stepper1.setMaxSpeed(50.0);    // Max Geschwindigkeit, Beschleunigung und gesetzte Geschwindigkeit einstellen 
  stepper1.setAcceleration(200.0);// Zum Suchen des Endschalters langsam fahren
                                  //stepper1.setSpeed(50); ist unnoetig, MaxSpeed genuegt        
  stepper1.setCurrentPosition(0); // Position definiert auf "0" setzen
  stepper1.moveTo(-20000);         // Einen weiten Weg vorgeben, damit die Drehscheibe den Endschalter erreicht
                                   // Wir wissen auch, dass vor dem Abschalten die Position >0 war, deshalb
                                   // suchen wir den Endschalter in der anderen Richtung
  // Setup sieht eigentlich keine Schleifen vor, deshalb "kuenstlich" mit while konstruiert
  endSchalter = digitalRead(12);  // Endschalter einlesen, damit in der while-Schleife ein definierter Zustand entstejht
  while (endSchalter == HIGH){    // Diese Schleife durchlaufen, solange der Endschalter nicht erreicht ist.
    endSchalter = digitalRead(12);  // Endschalter bei jedem Durchlauf testen
    stepper1.run ();                // Besonderheit des Arduino, die Funktion muss haeufig aufgerufen werden (wie oft ?) 
  }
  // Endschalter wurde erreicht, while Schleife wird verlassen 
  stepper1.stop();                  // Stepper anhalten
  delay (1000);                     // Warten, bis er steht
  Serial.println ("Endschalter erreicht");
  stepper1.setMaxSpeed(500.0);     // Nun Motor schneller machen fuer Normalbetrieb
  stepper1.setAcceleration(50.0);
  stepper1.setCurrentPosition(0);   // Dies ist nun die endgueltige "Nullposition", von der aus alle Bewegungen
                                    // gezaehlt werden
  stepper1.moveTo(200);         // auf Gleis 0 fahren

  while (stepper1.distanceToGo() != 0){    // Diese Schleife durchlaufen, solange der Stepper noch auf Position "0" laeuft.
    stepper1.run ();                // Besonderheit des Arduino, die Funktion muss haeufig aufgerufen werden (wie oft ?) 
  }
                                    // Drehscheibe steht jetzt auf Abgang "0"  
}//--(end setup )---

void loop() {

  if (irrecv.decode(&results)) //Falls der IR-Empfaenger Daten bekommen hat
  {  
// Die folgenden Zeilen zeigen den empfangenen IR-Code an. Sie koennen dazu verwendet werden
// eine unbekannte IR-Fernbedienung zu analysieren
    Serial.print("irCode: ");    // IR-Daten ausdrucken         
    Serial.print(results.value, HEX); // in HEX sonst wird's zu lang 

    Serial.print(" Value: ");    //
    Serial.print((unsigned int)((long)results.value & (long)0x0000FFFF)); //nur die untersten 4 HEX Zahlen 

    Serial.print(",  bits: ");  //Zahl der Bits im IR-Telegramm         
    Serial.println(results.bits); //

// Der folgende Code behandelt die empfangenen Daten. Die Konstanten in "case" wurden zuvor aus den oben
// gewonnenen Daten extrahiert. Die "moveTo" Daten sind im Augenblick mehr oder weniger willkuerlich,
// sie muessen an die tatsaechlichen Werte angepasst werden.

    switch(results.value)
    {
      case 0xFF6897:
       Serial.println("0 gedrueckt");
       stepper1.moveTo(200);                 // Hier den Wert fuer Abgang "0" eintragen
       digitalWrite (13,LOW);              //  Umpolrelais fuer Bruecke aus
      break;
  
      case 0xFF30CF:
        Serial.println("1 gedrueckt");    // Und hier fuer Abgang 1 etc.
        stepper1.moveTo(1907);
        digitalWrite (13,LOW);            //  Umpolrelais fuer Bruecke aus
      break;
  
     case 0xFF18E7:
        Serial.println("2 gedrueckt");
        stepper1.moveTo(3614);
        digitalWrite (13,LOW);  //  Umpolrelais fuer Bruecke aus
     break;
  
     case 0xFF7A85:
        Serial.println("3 gedrueckt");
        stepper1.moveTo(5321);
        digitalWrite (13,LOW);  //  Umpolrelais fuer Bruecke aus
     break;

     case 0xFF10EF:
        Serial.println("4 gedrueckt"); // Bei mir ist Stellung 4 gerade 180 Grad
        stepper1.moveTo(7028);
        digitalWrite (13,HIGH);  //  Umpolrelais fuer Bruecke ein. Ab hier ist das Umpolrelais eingeschaltet
     break;

     case 0xFF38C7:
       Serial.println("5 gedrueckt");
       stepper1.moveTo(8735);
       digitalWrite (13,HIGH);  //  Umpolrelais fuer Bruecke ein
     break;

     case 0xFF5AA5:
       Serial.println("6 gedrueckt");
       stepper1.moveTo(10442);
       digitalWrite (13,HIGH);  //  Umpolrelais fuer Bruecke ein
     break;

     case 0xFF42BD:
       Serial.println("7 gedrueckt");
       stepper1.moveTo(12149);
       digitalWrite (13,HIGH);  //  Umpolrelais fuer Bruecke ein
     break;
     
// Falls keine der obigen Bedingungen erfuellt wird z.B. falsche Taste gedrueckt oder falsche IR-Fernbedienung
// default - tu nix
      default:
      break;
    }
    irrecv.resume();    // Suche nach dem naechste IR-Telegramm 
  }
  stepper1.run ();    // wie gesagt, muss haeufig aufgerufen werden...
}
